package internetBanking;
/**
 * Internet Banking Simulation.
 * Simple Java project to illustrate the power of refactorings in modern IDEs
 */

/**
 * @author sergedemeyer - September 2015
 *
 */
public class InternetBankingMain {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Customer customer = new Customer(33);

		System.out.println("Created customer with nr " + customer.get_customerNr() + ".");

		Bank bank = new Bank();
		System.out.println("Created a bank.");

		if (bank.valid_customer(customer)) {
			System.out.println("Customer is valid.");
		} else {
			System.out.println("Customer is not valid.");
			return;
		}

		int accountNr1 = bank.createAccountForCustomer(customer);
		System.out.println("Created account for customer with nr " + accountNr1 + ".");
		if (bank.customerMayAccess(customer, accountNr1)) {
			System.out.println("Customer is granted to access.");
		} else {
			System.out.println("Customer is not granted access.");
			return;
		}
		System.out.println(
				"Balance for account with number " + accountNr1 + " is " + bank.seeBalance(customer, accountNr1) + ".");

		int accountNr2 = bank.createAccountForCustomer(customer);
		System.out.println("Created account for customer with nr " + accountNr2 + ".");
		if (bank.customerMayAccess(customer, accountNr2)) {
			System.out.println("Customer is granted to access.");
		} else {
			System.out.println("Customer is not granted access.");
			return;
		}
		System.out.println(
				"Balance for account with number " + accountNr2 + " is " + bank.seeBalance(customer, accountNr2) + ".");

		bank.transfer(customer, accountNr1, accountNr2, 2000);
		System.out.println("Transferrred 2000 from accountrNr1 to accountNr2.");
		System.out.println(
				"Balance for account with number " + accountNr1 + " is " + bank.seeBalance(customer, accountNr1) + ".");
		System.out.println(
				"Balance for account with number " + accountNr2 + " is " + bank.seeBalance(customer, accountNr2) + ".");
		bank.transfer(customer, accountNr2, accountNr1, 2000);
		System.out.println("Transferrred 2000 from accountrNr2 to accountNr1.");
		System.out.println(
				"Balance for account with number " + accountNr1 + " is " + bank.seeBalance(customer, accountNr1) + ".");
		System.out.println(
				"Balance for account with number " + accountNr2 + " is " + bank.seeBalance(customer, accountNr2) + ".");

		//DesignByContract dbc = new DesignByContract();
		// dbc.triggerPreconditionViolation();
		// dbc.triggerPostconditionViolation();
		//dbc.triggerInvariantViolation();
	}
}
